var IS_DEBUG = false;
var SYSYTEM_TYPE = '';

var MAIN_CORE_COUNT = 0;
var SCAN_STATE = 'off';

var RECEIVE_BUFFER = '';

var HAS_GOT_INIT = false;
var HAS_CHECKED_VERSION = false;
var HAS_SHOW_BLE_OPEN_TIPS = false;
var HAS_S_ZONE = false;

var IS_UPDATING = false;
var UPDATING_BIN_DATA = '';

var DRINK_TYPES;

var ACTIVE_CURRENT_ACTUAL_TEMP = 0;
var ACTIVE_CURRENT_SHOW_TEMP = '--';
var ACTIVE_WORKING_STATE = null; /* null:未连接 , 0: 空闲, 1: 加热, 2:保温*/
var ACTIVE_ELECTRIC = 0;
var ACTIVE_IS_CHARGING = false;
var ACTIVE_HAS_DRUNK = false;
var ACTIVE_IS_F = false;
var ACTIVE_IS_F_0 = false;
var ACTIVE_TARGET_ACTUAL_TEMP = 0;
var ACTIVE_TARGET_SHOW_TEMP = 55;
var ACTIVE_TARGET_SHOW_TEMP_0 = 55;
var ACTIVE_DRINK_TYPE_NUM = 0;
var ACTIVE_DRINK_TYPE_NUM_0 = 0;

var INIT_DEVICE_VERSION = 3;

var BLE_STATE = 'disconnected';
var BLE_STATE_0 = BLE_STATE;
var BLE_STATE_CHANGE_TIME = (new Date()).valueOf();
var BLE_STATE_CHANGE_TIME_0 = BLE_STATE_CHANGE_TIME;

//var HTTP_SAVE_DATA = [];
var IS_UPLOADING_HTTP_SAVE_DATA = false;

var MAC = '';

var SLANG;


apiready = function () {
	api.lockSlidPane();
	
	SLANG = new Slang(navigator.language);
	language_replace();
	
	 $api.fixStatusBar($api.dom('.navigator'));
    if(IS_DEBUG){
    	$api.removeCls($api.byId('logs_icon'), 'hide');
    }

	var inner_box = $api.dom('.inner_box');
	inner_box.style.width = (2340+$api.offset(document.body).w) + 'px';
	
	config('current_hardware_version', '');
	
	ACTIVE_IS_F = ACTIVE_IS_F_0 = config('is_fahrenheit');
	ACTIVE_TARGET_SHOW_TEMP = ACTIVE_TARGET_SHOW_TEMP_0 = ACTIVE_IS_F?131:55;
	
	add_listeners();
	
	var device_info = config('device_info');
	if(device_info && device_info.mac){
		MAC = device_info.mac;
	}
	on_received_data(process_receive_msg);
	start_ble(MAC);
	
	main_core_thread();
	
	upload_local_storage();
    
    init_drink_data();
    
    init_drink_types();
    
    var user_info = config('user_info.smart_id');
    if(user_info){
    	try{
			var send_data = {m_id: 10, smart_id: parseInt(user_info.smart_id)};
			send_data = Object.assign(send_data, get_system_info());
			send_data.location = config('location');
			send_statistic_data(send_data);
		}catch(e){}
    }
};

function set_disconnected_values(){
	RECEIVE_BUFFER = '';
	
	HAS_GOT_INIT = false;
	
	ACTIVE_CURRENT_SHOW_TEMP = '--';
	ACTIVE_WORKING_STATE = null; /* null:未连接 , 0: 空闲, 1: 加热, 2:保温*/
	ACTIVE_ELECTRIC = 0;
	ACTIVE_IS_CHARGING = false;
	ACTIVE_HAS_DRUNK = false;
}

function main_core_thread(){
	setTimeout(main_core_thread, 500);
	if(IS_UPDATING) return;
	
	MAIN_CORE_COUNT++;
	
	if(MAIN_CORE_COUNT%1 == 0){
		BLE_STATE = get_ble_state();
		if(BLE_STATE!="connected"){
			HAS_GOT_INIT = false;
			HAS_S_ZONE = false;
			set_disconnected_values();
		}
		
		check_ruler_moving();
	}
	
	if(MAIN_CORE_COUNT%2 == 0){
		
//		check_time_left();
		
		refresh_page_active_data();
	}
	
	if(MAIN_CORE_COUNT%6 == 0){
		init_device_data();
		if(BLE_STATE=="closed"){
			if(!HAS_SHOW_BLE_OPEN_TIPS){
				HAS_SHOW_BLE_OPEN_TIPS = true;
				weui_alert({msg: SLANG.INFO_OPEN_BLUETOOTH});
			}
		}
	}
	
	if(MAIN_CORE_COUNT>10000) MAIN_CORE_COUNT = 0;
}

/**
 * 测试是需要加载的数据
 */
function add_listeners(){
	
	api.addEventListener({
        name: 'keyback'
    }, function(ret, err){
//      api.closeWidget();
    });
    
	api.addEventListener({
	    name:'viewappear'
    },function(ret,err){
		check_device_info();
    });
    
//	api.addEventListener({
//	    name:'pause'
//  },function(ret,err){
//  	if (SYSYTEM_TYPE == 'ios') {
//			delay_stop_ble(120);
//		}
//  });
//  
//	api.addEventListener({
//	    name:'resume'
//  },function(ret,err){
//  	start_ble(MAC);
//		check_device_info();
//  });
    
	api.addEventListener({
	    name:'start_index_connect'
    },function(ret,err){
    	if(ret&&ret.value){
    		BLE_CONNECT_OPR = 'connect';
    		_BLE_DEVICE_UUID_ = ret.value.mac;
    	}
    	
    });
    
	api.addEventListener({
	    name:'stop_index_connect'
    },function(ret,err){
    	BLE_CONNECT_OPR = 'disconnect';
    });
    
	api.addEventListener({
	    name:'send_index_command'
    },function(ret,err){
    	if(ret&&ret.value){
    		send_command_to_ble_device(ret.value.command);
    	}
    });
    
    api.addEventListener({
	    name:'set_index_var'
    },function(ret,err){
    	if(ret&&ret.value){
    		var key = ret.value.key;
    		var val = ret.value.val;
    		
    		switch(typeof val){
    			case 'string':
    				eval('('+key+'="'+val+'")');
    			break;
    			
    			case 'boolean':
    			case 'number':
    				eval('('+key+'='+val+')');
    			break;
    		}
    	}
    });
    
    api.addEventListener({
	    name:'run_index_function'
    },function(ret,err){
    	if(ret&&ret.value){
    		var code = ret.value.code;
    		api.toast({msg:code });
    		eval(code);
    	}
    });
    
    api.addEventListener({
	    name:'init_drink_types'
    },function(ret,err){
    	init_drink_types();
    });
    
    api.addEventListener({
	    name:'assign_drink_data'
    },function(ret,err){
    	if(ret&&ret.value) assign_drink_data(ret.value.raw_data);
    });
    
    api.addEventListener({
	    name:'online'
	}, function(ret, err){        
	    upload_local_storage();
	});
}

function init_drink_types(){
	DRINK_TYPES = config('drink_type');
	if(!DRINK_TYPES){
		DRINK_TYPES = get_default_drink_types();
	}
}

function send_search(){
	weui_toast({msg: SLANG.INFO_SENT});
	send_command_to_ble_device('["set_search"]');
}

function process_receive_msg(str){
	if(IS_UPDATING){
		write_log('++++++IS_UPDATING+++++++: '+IS_UPDATING);
		process_update_msg(str);
	}else{
		process_device_msg(str);
	}
}

// 初始化水杯数据
function init_device_data(){
	if(BLE_STATE == "connected"){
		if(!HAS_GOT_INIT){
			send_command_to_ble_device('["get_init"]');
		}else if(!HAS_CHECKED_VERSION){
			send_command_to_ble_device('["get_version"]');
		}else if(ACTIVE_HAS_DRUNK){
			send_command_to_ble_device('["get_drink_data"]');
		}else{
			send_command_to_ble_device('["get_active"]');
			if(!HAS_S_ZONE){
			    setTimeout(function(){
			    	HAS_S_ZONE = true;
					var time = new Date();
				    var s_zone_data = ['s_zone', time.getFullYear()-2000, time.getMonth() + 1, time.getDate(), time.getHours(), time.getMinutes()];
				    send_command_to_ble_device($api.jsonToStr(s_zone_data));
			    }, 1000);
			}
		}
	}
}

function process_device_msg(str){
	RECEIVE_BUFFER += str;
	if(!RECEIVE_BUFFER) return;
    var msg = correct_cmd(RECEIVE_BUFFER);

    if (msg == '') return;
    RECEIVE_BUFFER = '';
    
	var data = [];
	try{
		write_log('@ execute: '+ msg);
		data = $api.strToJson(msg);
	}catch(e){}
	
	switch(data[0]){
		case 'init':
			HAS_GOT_INIT = true;
			HAS_CHECKED_VERSION = false;
			init_device_data();
			
			INIT_DEVICE_VERSION = data[1];
			
			config('smart_remind', data[3]?true:false);
			
			if(typeof data[11] != 'undefined'){
				ACTIVE_TARGET_SHOW_TEMP = data[11];
				config('target_show_temp', ACTIVE_TARGET_SHOW_TEMP);
				api.sendEvent({
		            name:'show_target_temp',
		            extra: {
				        target_temp: ACTIVE_TARGET_SHOW_TEMP
				    }
	            });
				ACTIVE_TARGET_ACTUAL_TEMP = ACTIVE_IS_F?f_to_c(ACTIVE_TARGET_SHOW_TEMP):ACTIVE_TARGET_SHOW_TEMP;
			}
		break;
		
		case 'active':
			ACTIVE_CURRENT_SHOW_TEMP = data[1];
			
			ACTIVE_CURRENT_ACTUAL_TEMP = ACTIVE_IS_F?f_to_c(ACTIVE_CURRENT_SHOW_TEMP):ACTIVE_CURRENT_SHOW_TEMP;
			ACTIVE_WORKING_STATE = data[2];
			ACTIVE_ELECTRIC = data[3]-520;
			ACTIVE_IS_CHARGING = data[4]?true:false;
			ACTIVE_HAS_DRUNK = data[5]?true: false;
			if(ACTIVE_HAS_DRUNK){
				send_command_to_ble_device('["get_drink_data"]');
			}
			
			
			ACTIVE_IS_F = data[6]?true: false;
			if(ACTIVE_IS_F != ACTIVE_IS_F_0){
				ACTIVE_IS_F_0 = ACTIVE_IS_F;
				config('is_fahrenheit', ACTIVE_IS_F?true:false);
				api.sendEvent({
		            name:'show_temp_unit',
		            extra: {
				        is_f: ACTIVE_IS_F
				    }
	            });
			}
			
			if(typeof data[7] != 'undefined'){
				ACTIVE_TARGET_SHOW_TEMP = data[7];
				if(ACTIVE_TARGET_SHOW_TEMP != ACTIVE_TARGET_SHOW_TEMP_0){
					ACTIVE_TARGET_SHOW_TEMP_0 = ACTIVE_TARGET_SHOW_TEMP;
					config('target_show_temp', ACTIVE_TARGET_SHOW_TEMP);
					api.sendEvent({
			            name:'show_target_temp',
			            extra: {
					        target_temp: ACTIVE_TARGET_SHOW_TEMP
					    }
		            });
				}
				ACTIVE_TARGET_ACTUAL_TEMP = ACTIVE_IS_F?f_to_c(ACTIVE_TARGET_SHOW_TEMP):ACTIVE_TARGET_SHOW_TEMP;
			}
			
			if(typeof data[8] != 'undefined'){
				ACTIVE_DRINK_TYPE_NUM = data[8];
				if(ACTIVE_DRINK_TYPE_NUM != ACTIVE_DRINK_TYPE_NUM_0){
					ACTIVE_DRINK_TYPE_NUM_0 = ACTIVE_DRINK_TYPE_NUM;
					config('cur_type_num', ACTIVE_DRINK_TYPE_NUM);
				}
			}
		break;
		
		case 'drink_data':
			ACTIVE_HAS_DRUNK = false;
			if(data[1]){
				data[1] += '';
				var date_str = '20' + data[1].substr(0,2) + '/' + data[1].substr(2,2) + '/' + data[1].substr(4,2) + ' ' + data[1].substr(6,2) + ':' + data[1].substr(8,2) + ':00';
				var time_stamp = (new Date(date_str).getTime())/1000;
				
				try{
					HISTORY_RAW_DATA.push({drink_time:time_stamp, drink_data:data[2]});
					api.sendEvent({
	                    name:'assign_drink_data',
	                    extra: {
					        raw_data: HISTORY_RAW_DATA
					    }
                    });
                    
					var upload_drink_data = get_upload_drink_data();
					upload_drink_data.push({drink_time:time_stamp, drink_data:data[2] });
					set_upload_drink_data(upload_drink_data);
					
					var user_info = config('user_info');
					if(user_info){
						set_http_drink_data(user_info, get_upload_drink_data());
					}
				}catch(e){}
				
				
				send_command_to_ble_device('["get_drink_data"]');
				ACTIVE_HAS_DRUNK = true;
			}
		break;
		
		case 'notice_interval':
			try{
				config('notice_interval', data[1]);
				config('renotice_interval', data[2]);
				api.sendEvent({
		            name:'init_notice_interval',
	            });
			}catch(e){}
		break;
		
		case 'version':
			HAS_CHECKED_VERSION = true;
			init_device_data();
			api.sendEvent({
	            name:'set_current_hardware_version',
	            extra: {
			        hardware_version: data[1]
			    }
            });
            config('current_hardware_version', data[1]);
		break;
	}
}

function refresh_page_active_data(){
	if(IS_TOUCH_MOVING == false){
		$api.html($api.byId('cur_temp'), ACTIVE_CURRENT_SHOW_TEMP);
	}
	
	$api.html($api.dom('.title'),get_name_by_version(INIT_DEVICE_VERSION));
	
	if(BLE_STATE=="connected"){
		$api.attr($api.byId('icon-bluetooth'), 'class', 'icon icon-bluetooth-1');
		switch(ACTIVE_WORKING_STATE){
			case 0:
				$api.html($api.byId('working'), SLANG.STAT_IDLE);
			break;
			
			case 1:
			case 2:
				$api.html($api.byId('working'),SLANG.STAT_WORKING);
			break;
			
			default:
				$api.html($api.byId('working'),SLANG.STAT_IDLE);
		}
		$api.attr($api.byId('waiting_dot'), 'style', 'display:none;');
	}else{
		$api.attr($api.byId('icon-bluetooth'), 'class', 'icon icon-bluetooth-0');
		ACTIVE_WORKING_STATE = null;
		$api.html($api.byId('working'), SLANG.STAT_NOT_CONNECT);
		$api.attr($api.byId('waiting_dot'), 'style', '');
	}
	
	try{
		if(BLE_STATE!=BLE_STATE_0){
			BLE_STATE_0 = BLE_STATE;
			
			BLE_STATE_CHANGE_TIME = (new Date()).valueOf();
			var need_time = Math.round(BLE_STATE_CHANGE_TIME - BLE_STATE_CHANGE_TIME_0)/1000;
			BLE_STATE_CHANGE_TIME_0 = BLE_STATE_CHANGE_TIME;
			
//			var send_data = config('device_info');
//			send_data.smart_id = config('user_info.smart_id');
//			send_data.ble_status = BLE_STATE;
//			send_data.m_id = 15;
//			send_data.need_time = need_time;
//			send_data.device_model = api.deviceModel;
//			send_statistic_data(send_data);
		}
	}catch(e){}
	
	
    var electric_level = Math.floor(ACTIVE_ELECTRIC / 25);
    if (electric_level > 4) {
        electric_level = 4;
    }
    if (electric_level < 0) {
        electric_level = 0;
    }
    $api.attr($api.byId('electric'), 'class', 'icon icon-battery-'+electric_level);
    
    if(ACTIVE_IS_CHARGING){
    	$api.removeCls($api.byId('charge_icon'), 'hide');
    }else{
    	$api.addCls($api.byId('charge_icon'), 'hide');
    }
	
	$api.html($api.dom('.temp_unit'), ACTIVE_IS_F?'℉':'℃');
	switch (INIT_DEVICE_VERSION){
		case 1:
			$api.removeCls($api.byId('history_info_box'), 'hide');
			$api.addCls($api.byId('temp_ruler_box'), 'hide');
			$api.addCls($api.byId('one_key_box'), 'hide');
			
			$api.addCls($api.byId('show_history_btn'), 'hide');
			
		break;

		case 2:
			$api.removeCls($api.byId('one_key_box'), 'hide');
			$api.addCls($api.byId('temp_ruler_box'), 'hide');
			$api.addCls($api.byId('history_info_box'), 'hide');
			
			$api.removeCls($api.byId('show_history_btn'), 'hide');
			
			$api.html($api.dom('.one_key_text'), SLANG.HTML_ONE_KEY_FOR + (ACTIVE_IS_F?'131℉':'55℃') );
			
			if(ACTIVE_WORKING_STATE==0){
				$api.html($api.dom('.one_key_img_box'), '<img src="../image/one_key.png" onclick="one_key_55c()" />');
			}else{
				$api.html($api.dom('.one_key_img_box'), '<img src="../image/one_key_disabled.png" />');
			}
		break;

		case 3:
			$api.removeCls($api.byId('temp_ruler_box'), 'hide');
			$api.addCls($api.byId('one_key_box'), 'hide');
			$api.addCls($api.byId('history_info_box'), 'hide');
			
			$api.removeCls($api.byId('show_history_btn'), 'hide');
			
			var drink_name = (ACTIVE_DRINK_TYPE_NUM>=0&&ACTIVE_DRINK_TYPE_NUM<9)?DRINK_TYPES[ACTIVE_DRINK_TYPE_NUM].name : SLANG.MODE_CUSTOM;
			$api.html($api.byId('index_mode_name'),'['+drink_name+']');
			
			if(IS_TOUCH_MOVING){
				
			}else{
				$api.html($api.byId('temp_value_1'), ACTIVE_TARGET_SHOW_TEMP);
				set_position_by_showtemp(ACTIVE_TARGET_SHOW_TEMP);
			}
			
			$api.html($api.byId('temp_unit_1'), ACTIVE_IS_F?'℉':'℃');
			
		break;
	}
}

function show_drink_num(index){
	show_num_text(index);
	if(!IS_SHOWING_NUM){
		IS_SHOWING_NUM = true;
		setTimeout(function(){
			IS_SHOWING_NUM = false;
			show_num_text(6);
		}, 5000);
	}
}

function show_num_text(index){
	var els = $api.domAll('.txt-top-s2');
	for(var i=0; i<els.length; i++){
		if(i==index){
			$api.addCls(els[i], 'txt-top-today-s2');
		}else{
			$api.removeCls(els[i], 'txt-top-today-s2');
		}
	}
}


function one_key_55c(){
	weui_toast({msg: SLANG.INFO_SENT});
	var cmd = $api.jsonToStr(['set_drink', ACTIVE_IS_F?131:55]);
	send_index_command(cmd);
}

TEMP_DIFF = 0;
ACTIVE_CURRENT_ACTUAL_TEMP_0 = 0;
ACTIVE_TARGET_ACTUAL_TEMP_0 = 0;
WORKING_TIME_LEFT = 0;
function check_time_left(){
	TEMP_DIFF = Math.round(ACTIVE_TARGET_ACTUAL_TEMP - ACTIVE_CURRENT_ACTUAL_TEMP);
	if(BLE_STATE=="connected"){
		if(ACTIVE_WORKING_STATE==1||ACTIVE_WORKING_STATE==2){
			if(ACTIVE_CURRENT_ACTUAL_TEMP!=ACTIVE_CURRENT_ACTUAL_TEMP_0 || ACTIVE_TARGET_ACTUAL_TEMP!=ACTIVE_TARGET_ACTUAL_TEMP_0){
				ACTIVE_CURRENT_ACTUAL_TEMP_0 = ACTIVE_CURRENT_ACTUAL_TEMP;
				ACTIVE_TARGET_ACTUAL_TEMP_0 = ACTIVE_TARGET_ACTUAL_TEMP;
				if(TEMP_DIFF<0){
					WORKING_TIME_LEFT = -TEMP_DIFF * 80;
				}else if(TEMP_DIFF>0){
					WORKING_TIME_LEFT = TEMP_DIFF * 42;
				}
			}
			if(TEMP_DIFF<0 || (TEMP_DIFF>0 && ACTIVE_IS_CHARGING)){
				WORKING_TIME_LEFT--;
				show_time_left(WORKING_TIME_LEFT);
				return;
			}
		}
	}
	WORKING_TIME_LEFT = 0;
	show_time_left(WORKING_TIME_LEFT);
}
function show_time_left(time_left){
	if(time_left<=0||time_left>8000){
		$api.html($api.byId('time_left'), '');
		return;
	}
	
	var minute = Math.floor(time_left / 60)
    var second = time_left % 60
    second = second<10?'0'+second:second;
	$api.html($api.byId('time_left'), minute + '\'' + second + '"');
}


function updating_hardware(){
	var filePath = 'fs://data/updata';
	UPDATING_BIN_DATA = api.readFile({
        sync:true,
        path:filePath
    });
    if(!UPDATING_BIN_DATA) {
    	show_updating_progress('fail');
    	return;
    }
    UPDATING_BIN_DATA = $api.strToJson(UPDATING_BIN_DATA);
    IS_UPDATING = true;
    send_index_command('[updata]');
    check_updating_progress()
}

var UPDATING_NEEDLE = 0;
var LAST_UPDATING_NEEDLE = 0;

function process_update_msg(msg){
	HAS_GOT_INIT = false;
	HAS_CHECKED_VERSION = false;
	
	if(msg.charCodeAt(0) == 0xa1){
		if(UPDATING_NEEDLE>=UPDATING_BIN_DATA.length){
			show_updating_progress('success');
			send_command_to_ble_device(String.fromCharCode(0xa9));
			IS_UPDATING = false;
			UPDATING_NEEDLE = 0;
			return;
		}else{
			send_command_to_ble_device(UPDATING_BIN_DATA[UPDATING_NEEDLE], true);
			UPDATING_NEEDLE++;
			show_updating_progress(Math.round(UPDATING_NEEDLE*100/UPDATING_BIN_DATA.length));
			return;
		}
	}
	if(msg.charCodeAt(0) == 0xa2){
		show_updating_progress('fail');
		IS_UPDATING = false;
		UPDATING_NEEDLE = 0;
	}
	if(msg.charCodeAt(0) == 0xa5){
		show_updating_progress('success');
		IS_UPDATING = false;
		UPDATING_NEEDLE = 0;
	}
}

function check_updating_progress(){
	setTimeout(function(){
		if(IS_UPDATING){
			if(LAST_UPDATING_NEEDLE==UPDATING_NEEDLE){
				show_updating_progress('fail');
				IS_UPDATING = false;
				UPDATING_NEEDLE = 0;
				return;
			}else{
				LAST_UPDATING_NEEDLE = UPDATING_NEEDLE;
				check_updating_progress();
			}
		}
	}, 5000);
}

function show_updating_progress(progress){
	api.sendEvent({
	    name:'show_updating_progress',
	    extra: {
	    	progress: progress
	    }
    });
}