var IS_TOUCH_MOVING = false;
var START_SCROLL_TIME = 0;
var DRAG_START_TIME;

function check_ruler_moving(){
	if(IS_TOUCH_MOVING == false) return;
	if(new Date().getTime() - DRAG_START_TIME < 1500) return; 
	
	IS_TOUCH_MOVING = false;
	var target_temp = get_showtemp_by_position();
	
	if(get_ble_state()!="connected") return;
	weui_confirm({
		msg: SLANG.INFO_CONFIRM_SET_TEMP_AT_TIPS+target_temp+(ACTIVE_IS_F?'℉':'℃')+'?',
		callback:function(ret){
    	if(ret){
    		if(ret.buttonIndex==0){
        	}else if(ret.buttonIndex==1){
    			var cmd = $api.jsonToStr(['set_varieties', 9, target_temp]);
    			send_command_to_ble_device(cmd);
        	}
    	}
    }
    });
}

function touchStartFunc(){
	IS_TOUCH_MOVING = true;
}

function touchMoveFunc(){
	DRAG_START_TIME = new Date().getTime();
	var show_temp = get_showtemp_by_position();
	if(IS_TOUCH_MOVING){
		$api.html($api.byId('cur_temp'), show_temp);
	}
	$api.html($api.byId('temp_value_1'), show_temp);
}

function set_position_by_showtemp(temp){
	if(ACTIVE_IS_F){
		var scroll_left = fahrenheit_to_scroll_left (temp);
	}else{
		var scroll_left = celsius_to_scroll_left(temp);
	}
	
   	$api.byId('ruler_box').scrollLeft = scroll_left;
}
function get_showtemp_by_position(){
	var scroll_left = $api.byId('ruler_box').scrollLeft;
	var target_temp = 0;
	if(ACTIVE_IS_F){
		return scroll_left_to_fahrenheit(scroll_left);
	}else{
		return scroll_left_to_celsius(scroll_left);
	}
	
}

function celsius_to_scroll_left(temp){
    return (temp - 35) * 36;
 }
function scroll_left_to_celsius(scroll_left){
   return Math.round(scroll_left / 36 + 35);
 }

function fahrenheit_to_scroll_left (temp) {
   return (temp - 95) * 20;
 }
function scroll_left_to_fahrenheit (scroll_left) {
   return Math.round(scroll_left / 20 + 95);
 }