
function open_menu(){
	api.openSlidPane({
	    type: 'left'
	});
}

function open_page(page, params){
	if(typeof params == 'undefined'){
		params = {};
	}
	api.openWin({
	    name: page,
	    url: page+'.html',
	    pageParam: params
    });
}

function close_page(page){
	api.closeWin({
		name: page,
    });
}


var WEUI_CALLBACK = null;
var WEUI_TIMEOUT = null;
function weui_alert(data){
	$api.remove($api.byId('weui_feekback'));
	data = data?data:{};
	WEUI_CALLBACK = data.callback;
	$api.append(document.body, '<div class="js_dialog" id="weui_feekback"><div class="weui-mask"></div><div class="weui-dialog"><div class="weui-dialog__bd">'+(data.msg?data.msg:'')+'</div><div class="weui-dialog__ft"><a href="javascript:;" class="weui-dialog__btn weui-dialog__btn_primary" style="color:#eb4200;" onclick="weui_click_func(1)">'+SLANG.OPR_OK+'</a></div></div></div>');
}
function weui_confirm(data){
	$api.remove($api.byId('weui_feekback'));
	data = data?data:{};
	WEUI_CALLBACK = data.callback;
	$api.append(document.body, '<div class="js_dialog" id="weui_feekback"><div class="weui-mask"></div><div class="weui-dialog"><div class="weui-dialog__hd"><strong class="weui-dialog__title">'+(data.title ? data.title :'')+'</strong></div><div class="weui-dialog__bd">'+(data.msg?data.msg:'')+'</div><div class="weui-dialog__ft"><a href="javascript:;" class="weui-dialog__btn weui-dialog__btn_default" onclick="weui_click_func(0)">'+(data.cancel_btn_text?data.cancel_btn_text:SLANG.OPR_CANCEL)+'</a><a href="javascript:;" class="weui-dialog__btn weui-dialog__btn_primary" style="color:#eb4200;" onclick="weui_click_func(1)">'+(data.ok_btn_text?data.ok_btn_text:SLANG.OPR_OK)+'</a></div></div></div>');
}
function weui_toast(data){
	$api.remove($api.byId('weui_toast'));
	clearTimeout(WEUI_TIMEOUT);
	data = data?data:{};
	WEUI_CALLBACK = data.callback;
	$api.append(document.body, '<div id="weui_toast"><div class="weui-mask_transparent"></div><div class="weui-toast"><i class="weui-icon-success-no-circle weui-icon_toast"></i><p class="weui-toast__content">'+(data.msg?data.msg:SLANG.INFO_COMPLETED)+'</p></div></div>');
	var fate_out_time = data.timeout?data.timeout:2000;
	WEUI_TIMEOUT = setTimeout(function(){
		$api.remove($api.byId('weui_toast'));
		weui_click_func(1);
	}, fate_out_time);
}
function weui_loading_toast(data){
//	$api.remove($api.byId('weui_toast'));
	clearTimeout(WEUI_TIMEOUT);
	data = data?data:{};
	
	if($api.byId('weui_toast')){
		$api.html($api.byId('weui_loading_toast_content'), data.msg?data.msg:SLANG.INFO_LOADING);
	}else{
		$api.append(document.body, '<div id="weui_toast"><div class="weui-mask_transparent"></div><div class="weui-toast"><i class="weui-loading weui-icon_toast"></i><p class="weui-toast__content" id="weui_loading_toast_content">'+(data.msg?data.msg:SLANG.INFO_LOADING)+'</p></div></div>');
	}
	var fate_out_time = data.timeout?data.timeout:3600000;
	WEUI_TIMEOUT = setTimeout(function(){
		$api.remove($api.byId('weui_toast'));
		weui_click_func(1);
	}, fate_out_time);
}
function weui_remove_toast(){
	$api.remove($api.byId('weui_toast'));
}

function weui_click_func(buttonIndex){
	$api.remove($api.byId('weui_feekback'));
	typeof WEUI_CALLBACK == 'function' && WEUI_CALLBACK({buttonIndex:buttonIndex});
	WEUI_CALLBACK = null;
}
 
function weixin_toast(data){
	var $toast = $('#toast');
	$('.weui-toast__content').html(data.msg);
    if ($toast.css('display') != 'none') return;

    $toast.fadeIn(100);
    setTimeout(function () {
        $toast.fadeOut(100);
    }, 2000);
}

function language_replace() {
	var template =$api.html(document.body); 
	Mustache.parse(template);   // optional, speeds up future uses
	var rendered = Mustache.render(template, SLANG);
    $api.html(document.body, rendered )
}

